module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 2);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.SET_ROOTPATH = '@@files-stack/SET_ROOTPATH';
exports.CHANGE_DIRECTORY_EXPAND = '@@files-stack/CHANGE_DIRECTORY_EXPAND';
exports.REFRESH_DIRECTORY = '@@files-stack/REFRESH_DIRECTORY';
exports.SET_CHILDREN_COUNT = '@@files-stack/SET_CHILDREN_COUNT';
exports.SELECT_FILE = '@@files-stack/SELECT_FILE';
exports.OPEN_FILE = '@@files-stack/OPEN_FILE';
exports.SAVE_FILE = '@@files-stack/SAVE_FILE';
exports.MUTATE_FILES = '@@files-stack/MUTATE_FILES';
exports.MUTATE_FILES_COMPLETE = '@@files-stack/MUTATE_FILES_COMPLETE';
exports.MUTATE_FILES_RESET = '@@files-stack/MUTATE_FILES_RESET';
exports.ADD_EDIT = '@@files-stack/ADD_EDIT';
exports.REMOVE_EDIT = '@@files-stack/REMOVE_EDIT';
exports.SELECT_EDIT = '@@files-stack/SELECT_EDIT';
exports.CHANGE_EDIT = '@@files-stack/CHANGE_EDIT';
exports.SAVE_EDIT = '@@files-stack/SAVE_EDIT';
exports.COLLAPSE_ALL = '@@files-stack/COLLAPSE_ALL';
exports.NEW_FILE = '@@files-stack/NEW_FILE';
exports.NEW_FOLDER = '@@files-stack/NEW_FOLDER';


/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
__export(__webpack_require__(7));
__export(__webpack_require__(0));


/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
__export(__webpack_require__(3));
__export(__webpack_require__(1));
__export(__webpack_require__(8));


/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const files_reducer_1 = __webpack_require__(4);
exports.reducers = Object.assign({}, files_reducer_1.reducers);


/***/ }),
/* 4 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const ramda_1 = __webpack_require__(5);
const actionTypes = __webpack_require__(0);
const core_1 = __webpack_require__(6);
function expand(state = [], action) {
    let index;
    switch (action.type) {
        case actionTypes.CHANGE_DIRECTORY_EXPAND:
            index = ramda_1.findIndex(ramda_1.propEq('resource', action.resource))(state);
            if (index !== -1) {
                state[index] = { resource: action.resource, expand: action.expand };
                return state.concat([]);
            }
            else if (action.expand) {
                return state.concat({ resource: action.resource, expand: action.expand });
            }
            else {
                return state;
            }
        case actionTypes.SET_CHILDREN_COUNT:
            index = ramda_1.findIndex(ramda_1.propEq('resource', action.resource))(state);
            if (index !== -1) {
                state[index] = Object.assign({}, state[index], { children: action.children });
                return state.concat([]);
            }
            else {
                return state;
            }
        case actionTypes.COLLAPSE_ALL:
            return [];
        default:
            return state;
    }
}
function refresh(state = 0, action) {
    switch (action.type) {
        case actionTypes.REFRESH_DIRECTORY:
            return state + 1;
        default:
            return state;
    }
}
function selectedFile(state = null, action) {
    switch (action.type) {
        case actionTypes.SELECT_FILE:
            return action.fileStat;
        default:
            return state;
    }
}
function rootpath(state = null, action) {
    switch (action.type) {
        case actionTypes.SET_ROOTPATH:
            return action.rootpath;
        default:
            return state;
    }
}
function mutateFiles(state = {}, action) {
    switch (action.type) {
        case actionTypes.MUTATE_FILES_RESET:
            return Object.assign({}, state, {
                mutation: '',
                options: {},
                calling: false,
            });
        case actionTypes.MUTATE_FILES_COMPLETE:
            return Object.assign({}, state, {
                calling: false,
            });
        case actionTypes.MUTATE_FILES:
            let newState = Object.assign({}, state, {
                calling: true,
                mutation: action.mutation,
                options: action.payload,
            });
            if (action.mutation === 'copy') {
                return Object.assign({}, newState, {
                    copyPath: action.payload.resource,
                });
            }
            else {
                return newState;
            }
        case actionTypes.NEW_FILE:
            return Object.assign({}, state, {
                calling: false,
                mutation: 'new-file',
                options: { resource: action.resource },
            });
        case actionTypes.NEW_FOLDER:
            return Object.assign({}, state, {
                calling: false,
                mutation: 'new-folder',
                options: { resource: action.resource },
            });
        default:
            return state;
    }
}
const initialEditState = {
    opening: [],
    oldValue: '',
    deleted: false,
};
function edit(state = initialEditState, action) {
    switch (action.type) {
        case actionTypes.OPEN_FILE:
            return Object.assign({}, state, {
                selected: action.resource,
                selectedName: action.selectedName,
                oldValue: action.oldValue,
                deleted: action.deleted,
            });
        case actionTypes.ADD_EDIT:
            var opening = state.opening;
            var index;
            if (action.content) {
                index = ramda_1.findIndex(ramda_1.whereEq({ resource: action.content.resource, name: state.selectedName }))(opening);
            }
            if (index === -1) {
                opening.push(Object.assign({}, action.content, {
                    newValue: !state.deleted && action.content ? action.content.value : '',
                    oldValue: state.oldValue,
                    name: state.selectedName,
                    resource: action.content.resource,
                    value: state.deleted ? '' : action.content.value,
                    deleted: state.deleted,
                }));
            }
            else {
                opening[index] = Object.assign({}, opening[index], {
                    value: opening[index].deleted ? '' : action.content.value,
                });
            }
            return Object.assign({}, state, {
                opening: opening.concat(),
                selected: core_1.getPath(action.content.resource),
                oldValue: '',
            });
        case actionTypes.REMOVE_EDIT:
            var opening = state.opening;
            var index = ramda_1.findIndex(ramda_1.whereEq({ 'resource': 'file://' + action.resource, name: action.selectedName }))(opening);
            if (index !== -1) {
                opening = ramda_1.remove(index, 1, opening);
            }
            return Object.assign({}, state, {
                opening: opening.concat(),
                selected: opening.length ? core_1.getPath(opening[index % opening.length].resource) : null,
                selectedName: opening.length ? opening[index % opening.length].name : null,
            });
        case actionTypes.SELECT_EDIT:
            var opening = state.opening;
            var index = ramda_1.findIndex(ramda_1.whereEq({ 'resource': 'file://' + action.resource, name: action.selectedName }))(opening);
            let selected = state.selected;
            let selectedName = state.selectedName;
            if (index !== -1) {
                selected = action.resource;
                selectedName = action.selectedName;
            }
            return Object.assign({}, state, {
                selected: selected,
                selectedName: selectedName,
            });
        case actionTypes.CHANGE_EDIT:
            var opening = state.opening;
            var index = ramda_1.findIndex(ramda_1.propEq('resource', 'file://' + state.selected))(opening);
            if (index !== -1) {
                opening[index] = Object.assign({}, opening[index], {
                    newValue: action.newValue,
                });
            }
            return Object.assign({}, state, {
                opening: opening.concat(),
            });
        default:
            return state;
    }
}
exports.reducers = {
    '@files/expand': expand,
    '@files/selectedFile': selectedFile,
    '@files/rootpath': rootpath,
    '@files/refresh': refresh,
    '@files/mutate': mutateFiles,
    '@files/edit': edit,
};


/***/ }),
/* 5 */
/***/ (function(module, exports) {

module.exports = require("ramda");

/***/ }),
/* 6 */
/***/ (function(module, exports) {

module.exports = require("@files-stack/core");

/***/ }),
/* 7 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const actionTypes = __webpack_require__(0);
exports.setRootpathAction = (rootpath) => ({
    type: actionTypes.SET_ROOTPATH,
    rootpath,
});
exports.changeDirectoryExpandAction = (resource, expand) => ({
    type: actionTypes.CHANGE_DIRECTORY_EXPAND, resource, expand,
});
exports.refreshDirectoryAction = () => ({
    type: actionTypes.REFRESH_DIRECTORY,
});
exports.setChildrenCountAction = (resource, children) => ({
    type: actionTypes.SET_CHILDREN_COUNT, resource, children,
});
exports.selectFileAction = (fileStat) => ({
    type: actionTypes.SELECT_FILE, fileStat,
});
exports.openFileAction = (resource, selectedName, oldValue, deleted) => ({
    type: actionTypes.OPEN_FILE, resource, selectedName, oldValue, deleted,
});
exports.resetMutateAction = () => ({
    type: actionTypes.MUTATE_FILES_RESET,
});
exports.completeMutateAction = () => ({
    type: actionTypes.MUTATE_FILES_COMPLETE,
});
exports.mutateFileAction = (mutation, options) => ({
    type: actionTypes.MUTATE_FILES, mutation, payload: options,
});
exports.addEditAction = (content) => ({
    type: actionTypes.ADD_EDIT, content,
});
exports.removeEditAction = (resource, selectedName) => ({
    type: actionTypes.REMOVE_EDIT, resource, selectedName,
});
exports.selectEditAction = (resource, selectedName) => ({
    type: actionTypes.SELECT_EDIT, resource, selectedName,
});
exports.changeEditAction = (newValue) => ({
    type: actionTypes.CHANGE_EDIT, newValue,
});
exports.saveEditAction = () => ({
    type: actionTypes.SAVE_EDIT,
});
exports.collapseAllAction = () => ({
    type: actionTypes.COLLAPSE_ALL,
});
exports.newFileAction = (resource) => ({
    type: actionTypes.NEW_FILE,
    resource,
});
exports.newFolderAction = (resource) => ({
    type: actionTypes.NEW_FOLDER,
    resource,
});


/***/ }),
/* 8 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
__export(__webpack_require__(9));


/***/ }),
/* 9 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const actions_1 = __webpack_require__(1);
exports.editorActions = (dispatch) => {
    return {
        id: actions_1.SET_ROOTPATH,
        label: 'Files: Set Root Path',
        run: (ed) => {
            const root = '/tmp';
            dispatch(actions_1.setRootpathAction(root));
        },
    };
};


/***/ })
/******/ ]);
//# sourceMappingURL=index.js.map